BEGIN {
    FS="=";
    print "# BEGIN";
    n="";       # Name of property
    v="";       # Value
    c=0; # Not a line continuation.
}
/^#/ { # The line is a comment.  Breaks line continuation.
    c=0;
    next;
}
/\\$/ && (c==0) && (NF>=2) { # Name value pair with a line continuation...
    e=index($0,"=");
    n=substr($0,1,e-1);
    v=substr($0,e+1,length($0) - e - 1);    # Trim off the backslash.
    c=1;                                    # Line continuation mode.
    next;
}
/^[^\\]+\\$/ && (c==1) { # Line continuation.  Accumulate the value.
    v= "" v substr($0,1,length($0)-1);
    next;
}
((c==1) || (NF>=2)) && !/^[^\\]+\\$/ { # End of line continuation, or a single line name/value pair
    if (c==0) {  # Single line name/value pair
        e=index($0,"=");
        n=substr($0,1,e-1);
        v=substr($0,e+1,length($0) - e);
    } else { # Line continuation mode - last line of the value.
        c=0; # Turn off line continuation mode.
        v= "" v $0;
    }
    # Replace '_' with '__'
    gsub(/_/,"__",n);
    gsub(/_/,"__",v);
    # Remove all leading and trailing spaces
    gsub(/^[ \t]+/,"",n);      # starting at the beginning and replace all consecutive tabs and spaces
    gsub(/[ \t]+$/,"",n);      # replace all consecutive tabs and spaces up to the end of string
    gsub(/^[ \t]+/,"",v);      # starting at the beginning and replace all consecutive tabs and spaces
    gsub(/[ \t]+$/,"",v);      # replace all consecutive tabs and spaces up to the end of string
    # Make sure the name is a legal shell variable name
    gsub(/ /,"",n);
    gsub(/[^A-Za-z0-9_]/,"_",n);
    # turn key into upper case
    n = toupper(n);
    # Remove newlines from the value.
    gsub(/[\n\r]/,"",v);
    print n"="v;
    n = "";
    v = "";
}
END {
    print "# END";
}

