#!/bin/bash

if [ ! -d $(pwd)/dmx-docker/plugins ]; then
    mkdir -p $(pwd)/dmx-docker/plugins
fi
if [ ! -d $(pwd)/dmx-docker/import ]; then
    mkdir -p $(pwd)/dmx-docker/import
fi
if [ ! -d $(pwd)/dmx-docker/conf.d ]; then
    mkdir -p $(pwd)/dmx-docker/conf.d
fi
if [ ! -d $(pwd)/dmx-docker/config.properties.d ]; then
    mkdir -p $(pwd)/dmx-docker/conf.d/config.properties.d
fi
if [ ! -d $(pwd)/dmx-docker/logging.properties.d ]; then
    mkdir -p $(pwd)/dmx-docker/conf.d/logging.properties.d
fi
if [ ! -d $(pwd)/dmx-docker/run.d ]; then
    mkdir -p $(pwd)/dmx-docker/run.d
fi

docker run \
    --volume $(pwd)/dmx-docker/logs:/opt/dmx/logs \
    --volume $(pwd)/dmx-docker/dmx-db:/opt/dmx/dmx-db \
    --volume $(pwd)/dmx-docker/dmx-filedir:/opt/dmx/dmx-filedir \
    --volume $(pwd)/dmx-docker/bundle-deploy:/opt/dmx/bundle-deploy \
    --volume $(pwd)/dmx-docker/bundle-available:/opt/dmx/bundle-available \
    --volume $(pwd)/dmx-docker/conf:/opt/dmx/conf \
    --volume $(pwd)/dmx-docker/plugins:/opt/dmx/plugins:ro \
    --volume $(pwd)/dmx-docker/import:/opt/dmx/import:ro \
    --volume $(pwd)/dmx-docker/conf.d:/opt/dmx/conf.d:ro \
    --volume $(pwd)/dmx-docker/run.d:/opt/dmx/run.d:ro \
    --env USER_ID=$(id -u) \
    --env GROUP_ID=$(id -g) \
    --publish 127.0.0.1:8080:8080 \
    --name dmx \
    --detach container-registry.dmx.systems/dmx-contrib/dmx-docker/dmx-5.3.2
